// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/CollisionDetection.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/collision_detection__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `gripper_id`
#include "rosidl_runtime_c/string_functions.h"
// Member `pre_grasp_offset`
#include "geometry_msgs/msg/detail/point__functions.h"

bool
rc_reason_msgs__msg__CollisionDetection__init(rc_reason_msgs__msg__CollisionDetection * msg)
{
  if (!msg) {
    return false;
  }
  // gripper_id
  if (!rosidl_runtime_c__String__init(&msg->gripper_id)) {
    rc_reason_msgs__msg__CollisionDetection__fini(msg);
    return false;
  }
  // pre_grasp_offset
  if (!geometry_msgs__msg__Point__init(&msg->pre_grasp_offset)) {
    rc_reason_msgs__msg__CollisionDetection__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__msg__CollisionDetection__fini(rc_reason_msgs__msg__CollisionDetection * msg)
{
  if (!msg) {
    return;
  }
  // gripper_id
  rosidl_runtime_c__String__fini(&msg->gripper_id);
  // pre_grasp_offset
  geometry_msgs__msg__Point__fini(&msg->pre_grasp_offset);
}

rc_reason_msgs__msg__CollisionDetection *
rc_reason_msgs__msg__CollisionDetection__create()
{
  rc_reason_msgs__msg__CollisionDetection * msg = (rc_reason_msgs__msg__CollisionDetection *)malloc(sizeof(rc_reason_msgs__msg__CollisionDetection));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__CollisionDetection));
  bool success = rc_reason_msgs__msg__CollisionDetection__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__CollisionDetection__destroy(rc_reason_msgs__msg__CollisionDetection * msg)
{
  if (msg) {
    rc_reason_msgs__msg__CollisionDetection__fini(msg);
  }
  free(msg);
}


bool
rc_reason_msgs__msg__CollisionDetection__Sequence__init(rc_reason_msgs__msg__CollisionDetection__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_reason_msgs__msg__CollisionDetection * data = NULL;
  if (size) {
    data = (rc_reason_msgs__msg__CollisionDetection *)calloc(size, sizeof(rc_reason_msgs__msg__CollisionDetection));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__CollisionDetection__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__CollisionDetection__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__CollisionDetection__Sequence__fini(rc_reason_msgs__msg__CollisionDetection__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__CollisionDetection__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__CollisionDetection__Sequence *
rc_reason_msgs__msg__CollisionDetection__Sequence__create(size_t size)
{
  rc_reason_msgs__msg__CollisionDetection__Sequence * array = (rc_reason_msgs__msg__CollisionDetection__Sequence *)malloc(sizeof(rc_reason_msgs__msg__CollisionDetection__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__CollisionDetection__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__CollisionDetection__Sequence__destroy(rc_reason_msgs__msg__CollisionDetection__Sequence * array)
{
  if (array) {
    rc_reason_msgs__msg__CollisionDetection__Sequence__fini(array);
  }
  free(array);
}
