// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/DetectedTag.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/detected_tag__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `tag`
#include "rc_reason_msgs/msg/detail/tag__functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose_stamped__functions.h"
// Member `instance_id`
#include "rosidl_runtime_c/string_functions.h"

bool
rc_reason_msgs__msg__DetectedTag__init(rc_reason_msgs__msg__DetectedTag * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    rc_reason_msgs__msg__DetectedTag__fini(msg);
    return false;
  }
  // tag
  if (!rc_reason_msgs__msg__Tag__init(&msg->tag)) {
    rc_reason_msgs__msg__DetectedTag__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__init(&msg->pose)) {
    rc_reason_msgs__msg__DetectedTag__fini(msg);
    return false;
  }
  // instance_id
  if (!rosidl_runtime_c__String__init(&msg->instance_id)) {
    rc_reason_msgs__msg__DetectedTag__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__msg__DetectedTag__fini(rc_reason_msgs__msg__DetectedTag * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // tag
  rc_reason_msgs__msg__Tag__fini(&msg->tag);
  // pose
  geometry_msgs__msg__PoseStamped__fini(&msg->pose);
  // instance_id
  rosidl_runtime_c__String__fini(&msg->instance_id);
}

rc_reason_msgs__msg__DetectedTag *
rc_reason_msgs__msg__DetectedTag__create()
{
  rc_reason_msgs__msg__DetectedTag * msg = (rc_reason_msgs__msg__DetectedTag *)malloc(sizeof(rc_reason_msgs__msg__DetectedTag));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__DetectedTag));
  bool success = rc_reason_msgs__msg__DetectedTag__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__DetectedTag__destroy(rc_reason_msgs__msg__DetectedTag * msg)
{
  if (msg) {
    rc_reason_msgs__msg__DetectedTag__fini(msg);
  }
  free(msg);
}


bool
rc_reason_msgs__msg__DetectedTag__Sequence__init(rc_reason_msgs__msg__DetectedTag__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_reason_msgs__msg__DetectedTag * data = NULL;
  if (size) {
    data = (rc_reason_msgs__msg__DetectedTag *)calloc(size, sizeof(rc_reason_msgs__msg__DetectedTag));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__DetectedTag__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__DetectedTag__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__DetectedTag__Sequence__fini(rc_reason_msgs__msg__DetectedTag__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__DetectedTag__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__DetectedTag__Sequence *
rc_reason_msgs__msg__DetectedTag__Sequence__create(size_t size)
{
  rc_reason_msgs__msg__DetectedTag__Sequence * array = (rc_reason_msgs__msg__DetectedTag__Sequence *)malloc(sizeof(rc_reason_msgs__msg__DetectedTag__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__DetectedTag__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__DetectedTag__Sequence__destroy(rc_reason_msgs__msg__DetectedTag__Sequence * array)
{
  if (array) {
    rc_reason_msgs__msg__DetectedTag__Sequence__fini(array);
  }
  free(array);
}
