// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:msg/RangeRectangle.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__RANGE_RECTANGLE__STRUCT_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__RANGE_RECTANGLE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'min_dimensions'
// Member 'max_dimensions'
#include "rc_reason_msgs/msg/detail/rectangle__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__msg__RangeRectangle __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__msg__RangeRectangle __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RangeRectangle_
{
  using Type = RangeRectangle_<ContainerAllocator>;

  explicit RangeRectangle_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : min_dimensions(_init),
    max_dimensions(_init)
  {
    (void)_init;
  }

  explicit RangeRectangle_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : min_dimensions(_alloc, _init),
    max_dimensions(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _min_dimensions_type =
    rc_reason_msgs::msg::Rectangle_<ContainerAllocator>;
  _min_dimensions_type min_dimensions;
  using _max_dimensions_type =
    rc_reason_msgs::msg::Rectangle_<ContainerAllocator>;
  _max_dimensions_type max_dimensions;

  // setters for named parameter idiom
  Type & set__min_dimensions(
    const rc_reason_msgs::msg::Rectangle_<ContainerAllocator> & _arg)
  {
    this->min_dimensions = _arg;
    return *this;
  }
  Type & set__max_dimensions(
    const rc_reason_msgs::msg::Rectangle_<ContainerAllocator> & _arg)
  {
    this->max_dimensions = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::msg::RangeRectangle_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::msg::RangeRectangle_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::RangeRectangle_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::RangeRectangle_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::RangeRectangle_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::RangeRectangle_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::RangeRectangle_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::RangeRectangle_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::RangeRectangle_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::RangeRectangle_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__msg__RangeRectangle
    std::shared_ptr<rc_reason_msgs::msg::RangeRectangle_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__msg__RangeRectangle
    std::shared_ptr<rc_reason_msgs::msg::RangeRectangle_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RangeRectangle_ & other) const
  {
    if (this->min_dimensions != other.min_dimensions) {
      return false;
    }
    if (this->max_dimensions != other.max_dimensions) {
      return false;
    }
    return true;
  }
  bool operator!=(const RangeRectangle_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RangeRectangle_

// alias to use template instance with default allocator
using RangeRectangle =
  rc_reason_msgs::msg::RangeRectangle_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__MSG__DETAIL__RANGE_RECTANGLE__STRUCT_HPP_
