// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from rc_reason_msgs:srv/ComputeGrasps.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__COMPUTE_GRASPS__BUILDER_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__COMPUTE_GRASPS__BUILDER_HPP_

#include "rc_reason_msgs/srv/detail/compute_grasps__struct.hpp"
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <utility>


namespace rc_reason_msgs
{

namespace srv
{

namespace builder
{

class Init_ComputeGrasps_Request_collision_detection
{
public:
  explicit Init_ComputeGrasps_Request_collision_detection(::rc_reason_msgs::srv::ComputeGrasps_Request & msg)
  : msg_(msg)
  {}
  ::rc_reason_msgs::srv::ComputeGrasps_Request collision_detection(::rc_reason_msgs::srv::ComputeGrasps_Request::_collision_detection_type arg)
  {
    msg_.collision_detection = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rc_reason_msgs::srv::ComputeGrasps_Request msg_;
};

class Init_ComputeGrasps_Request_robot_pose
{
public:
  explicit Init_ComputeGrasps_Request_robot_pose(::rc_reason_msgs::srv::ComputeGrasps_Request & msg)
  : msg_(msg)
  {}
  Init_ComputeGrasps_Request_collision_detection robot_pose(::rc_reason_msgs::srv::ComputeGrasps_Request::_robot_pose_type arg)
  {
    msg_.robot_pose = std::move(arg);
    return Init_ComputeGrasps_Request_collision_detection(msg_);
  }

private:
  ::rc_reason_msgs::srv::ComputeGrasps_Request msg_;
};

class Init_ComputeGrasps_Request_suction_surface_width
{
public:
  explicit Init_ComputeGrasps_Request_suction_surface_width(::rc_reason_msgs::srv::ComputeGrasps_Request & msg)
  : msg_(msg)
  {}
  Init_ComputeGrasps_Request_robot_pose suction_surface_width(::rc_reason_msgs::srv::ComputeGrasps_Request::_suction_surface_width_type arg)
  {
    msg_.suction_surface_width = std::move(arg);
    return Init_ComputeGrasps_Request_robot_pose(msg_);
  }

private:
  ::rc_reason_msgs::srv::ComputeGrasps_Request msg_;
};

class Init_ComputeGrasps_Request_suction_surface_length
{
public:
  explicit Init_ComputeGrasps_Request_suction_surface_length(::rc_reason_msgs::srv::ComputeGrasps_Request & msg)
  : msg_(msg)
  {}
  Init_ComputeGrasps_Request_suction_surface_width suction_surface_length(::rc_reason_msgs::srv::ComputeGrasps_Request::_suction_surface_length_type arg)
  {
    msg_.suction_surface_length = std::move(arg);
    return Init_ComputeGrasps_Request_suction_surface_width(msg_);
  }

private:
  ::rc_reason_msgs::srv::ComputeGrasps_Request msg_;
};

class Init_ComputeGrasps_Request_item_models
{
public:
  explicit Init_ComputeGrasps_Request_item_models(::rc_reason_msgs::srv::ComputeGrasps_Request & msg)
  : msg_(msg)
  {}
  Init_ComputeGrasps_Request_suction_surface_length item_models(::rc_reason_msgs::srv::ComputeGrasps_Request::_item_models_type arg)
  {
    msg_.item_models = std::move(arg);
    return Init_ComputeGrasps_Request_suction_surface_length(msg_);
  }

private:
  ::rc_reason_msgs::srv::ComputeGrasps_Request msg_;
};

class Init_ComputeGrasps_Request_load_carrier_compartment
{
public:
  explicit Init_ComputeGrasps_Request_load_carrier_compartment(::rc_reason_msgs::srv::ComputeGrasps_Request & msg)
  : msg_(msg)
  {}
  Init_ComputeGrasps_Request_item_models load_carrier_compartment(::rc_reason_msgs::srv::ComputeGrasps_Request::_load_carrier_compartment_type arg)
  {
    msg_.load_carrier_compartment = std::move(arg);
    return Init_ComputeGrasps_Request_item_models(msg_);
  }

private:
  ::rc_reason_msgs::srv::ComputeGrasps_Request msg_;
};

class Init_ComputeGrasps_Request_load_carrier_id
{
public:
  explicit Init_ComputeGrasps_Request_load_carrier_id(::rc_reason_msgs::srv::ComputeGrasps_Request & msg)
  : msg_(msg)
  {}
  Init_ComputeGrasps_Request_load_carrier_compartment load_carrier_id(::rc_reason_msgs::srv::ComputeGrasps_Request::_load_carrier_id_type arg)
  {
    msg_.load_carrier_id = std::move(arg);
    return Init_ComputeGrasps_Request_load_carrier_compartment(msg_);
  }

private:
  ::rc_reason_msgs::srv::ComputeGrasps_Request msg_;
};

class Init_ComputeGrasps_Request_region_of_interest_id
{
public:
  explicit Init_ComputeGrasps_Request_region_of_interest_id(::rc_reason_msgs::srv::ComputeGrasps_Request & msg)
  : msg_(msg)
  {}
  Init_ComputeGrasps_Request_load_carrier_id region_of_interest_id(::rc_reason_msgs::srv::ComputeGrasps_Request::_region_of_interest_id_type arg)
  {
    msg_.region_of_interest_id = std::move(arg);
    return Init_ComputeGrasps_Request_load_carrier_id(msg_);
  }

private:
  ::rc_reason_msgs::srv::ComputeGrasps_Request msg_;
};

class Init_ComputeGrasps_Request_pose_frame
{
public:
  Init_ComputeGrasps_Request_pose_frame()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_ComputeGrasps_Request_region_of_interest_id pose_frame(::rc_reason_msgs::srv::ComputeGrasps_Request::_pose_frame_type arg)
  {
    msg_.pose_frame = std::move(arg);
    return Init_ComputeGrasps_Request_region_of_interest_id(msg_);
  }

private:
  ::rc_reason_msgs::srv::ComputeGrasps_Request msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::rc_reason_msgs::srv::ComputeGrasps_Request>()
{
  return rc_reason_msgs::srv::builder::Init_ComputeGrasps_Request_pose_frame();
}

}  // namespace rc_reason_msgs


namespace rc_reason_msgs
{

namespace srv
{

namespace builder
{

class Init_ComputeGrasps_Response_return_code
{
public:
  explicit Init_ComputeGrasps_Response_return_code(::rc_reason_msgs::srv::ComputeGrasps_Response & msg)
  : msg_(msg)
  {}
  ::rc_reason_msgs::srv::ComputeGrasps_Response return_code(::rc_reason_msgs::srv::ComputeGrasps_Response::_return_code_type arg)
  {
    msg_.return_code = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rc_reason_msgs::srv::ComputeGrasps_Response msg_;
};

class Init_ComputeGrasps_Response_grasps
{
public:
  explicit Init_ComputeGrasps_Response_grasps(::rc_reason_msgs::srv::ComputeGrasps_Response & msg)
  : msg_(msg)
  {}
  Init_ComputeGrasps_Response_return_code grasps(::rc_reason_msgs::srv::ComputeGrasps_Response::_grasps_type arg)
  {
    msg_.grasps = std::move(arg);
    return Init_ComputeGrasps_Response_return_code(msg_);
  }

private:
  ::rc_reason_msgs::srv::ComputeGrasps_Response msg_;
};

class Init_ComputeGrasps_Response_load_carriers
{
public:
  explicit Init_ComputeGrasps_Response_load_carriers(::rc_reason_msgs::srv::ComputeGrasps_Response & msg)
  : msg_(msg)
  {}
  Init_ComputeGrasps_Response_grasps load_carriers(::rc_reason_msgs::srv::ComputeGrasps_Response::_load_carriers_type arg)
  {
    msg_.load_carriers = std::move(arg);
    return Init_ComputeGrasps_Response_grasps(msg_);
  }

private:
  ::rc_reason_msgs::srv::ComputeGrasps_Response msg_;
};

class Init_ComputeGrasps_Response_items
{
public:
  explicit Init_ComputeGrasps_Response_items(::rc_reason_msgs::srv::ComputeGrasps_Response & msg)
  : msg_(msg)
  {}
  Init_ComputeGrasps_Response_load_carriers items(::rc_reason_msgs::srv::ComputeGrasps_Response::_items_type arg)
  {
    msg_.items = std::move(arg);
    return Init_ComputeGrasps_Response_load_carriers(msg_);
  }

private:
  ::rc_reason_msgs::srv::ComputeGrasps_Response msg_;
};

class Init_ComputeGrasps_Response_timestamp
{
public:
  Init_ComputeGrasps_Response_timestamp()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_ComputeGrasps_Response_items timestamp(::rc_reason_msgs::srv::ComputeGrasps_Response::_timestamp_type arg)
  {
    msg_.timestamp = std::move(arg);
    return Init_ComputeGrasps_Response_items(msg_);
  }

private:
  ::rc_reason_msgs::srv::ComputeGrasps_Response msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::rc_reason_msgs::srv::ComputeGrasps_Response>()
{
  return rc_reason_msgs::srv::builder::Init_ComputeGrasps_Response_timestamp();
}

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__SRV__DETAIL__COMPUTE_GRASPS__BUILDER_HPP_
