// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:srv/DetectItems.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__DETECT_ITEMS__STRUCT_H_
#define RC_REASON_MSGS__SRV__DETAIL__DETECT_ITEMS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'pose_frame'
// Member 'region_of_interest_id'
// Member 'load_carrier_id'
#include "rosidl_runtime_c/string.h"
// Member 'load_carrier_compartment'
#include "rc_reason_msgs/msg/detail/compartment__struct.h"
// Member 'item_models'
#include "rc_reason_msgs/msg/detail/item_model__struct.h"
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__struct.h"

// Struct defined in srv/DetectItems in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__DetectItems_Request
{
  rosidl_runtime_c__String pose_frame;
  rosidl_runtime_c__String region_of_interest_id;
  rosidl_runtime_c__String load_carrier_id;
  rc_reason_msgs__msg__Compartment load_carrier_compartment;
  rc_reason_msgs__msg__ItemModel__Sequence item_models;
  geometry_msgs__msg__Pose robot_pose;
} rc_reason_msgs__srv__DetectItems_Request;

// Struct for a sequence of rc_reason_msgs__srv__DetectItems_Request.
typedef struct rc_reason_msgs__srv__DetectItems_Request__Sequence
{
  rc_reason_msgs__srv__DetectItems_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__DetectItems_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.h"
// Member 'items'
#include "rc_reason_msgs/msg/detail/item__struct.h"
// Member 'load_carriers'
#include "rc_reason_msgs/msg/detail/load_carrier__struct.h"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__struct.h"

// Struct defined in srv/DetectItems in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__DetectItems_Response
{
  builtin_interfaces__msg__Time timestamp;
  rc_reason_msgs__msg__Item__Sequence items;
  rc_reason_msgs__msg__LoadCarrier__Sequence load_carriers;
  rc_common_msgs__msg__ReturnCode return_code;
} rc_reason_msgs__srv__DetectItems_Response;

// Struct for a sequence of rc_reason_msgs__srv__DetectItems_Response.
typedef struct rc_reason_msgs__srv__DetectItems_Response__Sequence
{
  rc_reason_msgs__srv__DetectItems_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__DetectItems_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__SRV__DETAIL__DETECT_ITEMS__STRUCT_H_
