// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:srv/GetBasePlaneCalibration.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__GET_BASE_PLANE_CALIBRATION__STRUCT_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__GET_BASE_PLANE_CALIBRATION__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__GetBasePlaneCalibration_Request __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__GetBasePlaneCalibration_Request __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetBasePlaneCalibration_Request_
{
  using Type = GetBasePlaneCalibration_Request_<ContainerAllocator>;

  explicit GetBasePlaneCalibration_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : robot_pose(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pose_frame = "";
    }
  }

  explicit GetBasePlaneCalibration_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose_frame(_alloc),
    robot_pose(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pose_frame = "";
    }
  }

  // field types and members
  using _pose_frame_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _pose_frame_type pose_frame;
  using _robot_pose_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _robot_pose_type robot_pose;

  // setters for named parameter idiom
  Type & set__pose_frame(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->pose_frame = _arg;
    return *this;
  }
  Type & set__robot_pose(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->robot_pose = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::GetBasePlaneCalibration_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::GetBasePlaneCalibration_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::GetBasePlaneCalibration_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::GetBasePlaneCalibration_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__GetBasePlaneCalibration_Request
    std::shared_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__GetBasePlaneCalibration_Request
    std::shared_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetBasePlaneCalibration_Request_ & other) const
  {
    if (this->pose_frame != other.pose_frame) {
      return false;
    }
    if (this->robot_pose != other.robot_pose) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetBasePlaneCalibration_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetBasePlaneCalibration_Request_

// alias to use template instance with default allocator
using GetBasePlaneCalibration_Request =
  rc_reason_msgs::srv::GetBasePlaneCalibration_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs


// Include directives for member types
// Member 'plane'
#include "shape_msgs/msg/detail/plane__struct.hpp"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__GetBasePlaneCalibration_Response __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__GetBasePlaneCalibration_Response __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetBasePlaneCalibration_Response_
{
  using Type = GetBasePlaneCalibration_Response_<ContainerAllocator>;

  explicit GetBasePlaneCalibration_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : plane(_init),
    return_code(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pose_frame = "";
    }
  }

  explicit GetBasePlaneCalibration_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose_frame(_alloc),
    plane(_alloc, _init),
    return_code(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pose_frame = "";
    }
  }

  // field types and members
  using _pose_frame_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _pose_frame_type pose_frame;
  using _plane_type =
    shape_msgs::msg::Plane_<ContainerAllocator>;
  _plane_type plane;
  using _return_code_type =
    rc_common_msgs::msg::ReturnCode_<ContainerAllocator>;
  _return_code_type return_code;

  // setters for named parameter idiom
  Type & set__pose_frame(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->pose_frame = _arg;
    return *this;
  }
  Type & set__plane(
    const shape_msgs::msg::Plane_<ContainerAllocator> & _arg)
  {
    this->plane = _arg;
    return *this;
  }
  Type & set__return_code(
    const rc_common_msgs::msg::ReturnCode_<ContainerAllocator> & _arg)
  {
    this->return_code = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::GetBasePlaneCalibration_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::GetBasePlaneCalibration_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::GetBasePlaneCalibration_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::GetBasePlaneCalibration_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__GetBasePlaneCalibration_Response
    std::shared_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__GetBasePlaneCalibration_Response
    std::shared_ptr<rc_reason_msgs::srv::GetBasePlaneCalibration_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetBasePlaneCalibration_Response_ & other) const
  {
    if (this->pose_frame != other.pose_frame) {
      return false;
    }
    if (this->plane != other.plane) {
      return false;
    }
    if (this->return_code != other.return_code) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetBasePlaneCalibration_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetBasePlaneCalibration_Response_

// alias to use template instance with default allocator
using GetBasePlaneCalibration_Response =
  rc_reason_msgs::srv::GetBasePlaneCalibration_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rc_reason_msgs
{

namespace srv
{

struct GetBasePlaneCalibration
{
  using Request = rc_reason_msgs::srv::GetBasePlaneCalibration_Request;
  using Response = rc_reason_msgs::srv::GetBasePlaneCalibration_Response;
};

}  // namespace srv

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__SRV__DETAIL__GET_BASE_PLANE_CALIBRATION__STRUCT_HPP_
